/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.tasks.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for TaskList.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Tasks API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TaskList extends GenericJson {

  /**
   * ETag of the resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * Task list identifier.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Type of the resource. This is always "tasks#taskList".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * URL pointing to this task list. Used to retrieve, update, or delete this task list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String selfLink;

  /**
   * Title of the task list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**
   * Last modification time of the task list (as a RFC 3339 timestamp).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime updated;

  /**
   * ETag of the resource.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * ETag of the resource.
   * The value set may be {@code null}.
   */
  public TaskList setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * Task list identifier.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Task list identifier.
   * The value set may be {@code null}.
   */
  public TaskList setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Type of the resource. This is always "tasks#taskList".
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Type of the resource. This is always "tasks#taskList".
   * The value set may be {@code null}.
   */
  public TaskList setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * URL pointing to this task list. Used to retrieve, update, or delete this task list.
   * The value returned may be {@code null}.
   */
  public String getSelfLink() {
    return selfLink;
  }

  /**
   * URL pointing to this task list. Used to retrieve, update, or delete this task list.
   * The value set may be {@code null}.
   */
  public TaskList setSelfLink(String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Title of the task list.
   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**
   * Title of the task list.
   * The value set may be {@code null}.
   */
  public TaskList setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Last modification time of the task list (as a RFC 3339 timestamp).
   * The value returned may be {@code null}.
   */
  public DateTime getUpdated() {
    return updated;
  }

  /**
   * Last modification time of the task list (as a RFC 3339 timestamp).
   * The value set may be {@code null}.
   */
  public TaskList setUpdated(DateTime updated) {
    this.updated = updated;
    return this;
  }

}
